#include "CUDAFullRayCaster_basic.cu.h"

static __device__ 
float4 d_CastRay(const float4& voxel_zero,const float4& voxel_unit,const float4& CameraDirection,float tnear,float tfar)
{
	float t=tnear;
	float4 pos=voxel_zero + voxel_unit * t;
	float4 voxel_step=voxel_unit*c_sampleDistance;

	float4 acc=make_float4(0.0f);

	while(t<tfar && acc.w<0.98f)
    {
		float4 color=d_GetShadedColor(pos,CameraDirection);
		float alpha=color.w;
		if (alpha>0.0f)
		{
			color.w=1.0f;
			color*=alpha;		
			acc+=(1.0f-acc.w)*color;
		}
		t += c_sampleDistance;
		pos += voxel_step;
    }

	return acc;	

}