#ifndef __RGBATransferFunction1D_h
#define __RGBATransferFunction1D_h

#include "VolTKSceneIncludes.h"
#include "Lut1D.h"

#ifndef __RGBAPoint__
#define __RGBAPoint__
struct RGBAPoint
{
	float pos;
	Vector4 val;
};
#endif
class RGBAPointArray;
class VOLTK_SCENE_API RGBATransferFunction1D 
{
public:
	RGBATransferFunction1D();
	virtual ~RGBATransferFunction1D();

	Vector4* GetData();

	void SetSampleNumber(int Number);
	int GetSampleNumber() const;

    void SetMinPos(float Min);
    float GetMinPos() const;

    void SetMaxPos(float Max);
    float GetMaxPos() const;

	const Lut1D& GetLut1D() { Update(); return m_Lut; }

	int AddPoint(float pos,Vector4 value);

	int GetPointCount() const;
	float GetPos(int index) const;

    Vector4 GetValue(int index) const;

	void SetRGBAValue (int index,Vector4 value);

    void RemovePoint(int index);
	void RemoveAllPoints();

protected:	
	virtual void Update();

private:
	void _update();

	Lut1D m_Lut;
    RGBAPointArray *m_Points;
	bool m_NeedUpdate;

};


#endif
