#include "GridPartition.h"

static int bsize[3];
static int bnum[3];
static int incs[3];
static float *minmaxarray;

static inline void GetMinMax(int x,int y,int z,float &minV,float &maxV)
{
	x=max(min(x,bnum[0]-1),0);
	y=max(min(y,bnum[1]-1),0);
	z=max(min(z,bnum[2]-1),0);

	int pos=x*incs[0]+y*incs[1]+z*incs[2];
	minV=minmaxarray[pos];
	maxV=minmaxarray[pos+1];
}

static inline int ConvertToBlockIndex(int voxelIndex,int dimId)
{
	return voxelIndex/bsize[dimId];
}

static inline int ConvertToVoxelIndex(int blockIndex,int dimId)
{
	return blockIndex*bsize[dimId];
}

static bool GridPartitionPrepare(GridPartition *gp)
{
	if (!gp) return false;

	bsize[0]=gp->m_bsizeX;
	bsize[1]=gp->m_bsizeY;
	bsize[2]=gp->m_bsizeZ;

	bnum[0]=gp->m_bnumX;
	bnum[1]=gp->m_bnumY;
	bnum[2]=gp->m_bnumZ;

	incs[0]=2;
	incs[1]=incs[0]*bnum[0];
	incs[2]=incs[1]*bnum[1];

	minmaxarray=gp->m_MinMaxArray;

	return true;
}
